var myService = new function()
{
    var ROOT_PATH = 'mountpoint://shared';
    var DOWNLOAD_URI_SUFFIX    = '?download=true';
    var _activityStream        = new ActivityStream();

    function init()
    {
        Yusef.plugins.ui.setStyleSheet( "static/styles/fileSharing.css" );
    }

    function getResourcePathObject( fileObject, section )
    {
        var tmp = {};
        tmp.resourcePath        = ('/' + section + '/'+ fileObject.path.slice(ROOT_PATH.length) +'/').replace( /\/+/g, '/' );
        tmp.resourceFullPath    = opera.io.webserver.currentServicePath+ tmp.resourcePath.slice(1);
        tmp.HTMLName	        = unescape( fileObject.name ).HTMLEntities();
        return tmp;
    }

    Yusef.addSectionListener
    (
        '_index',
        function( connection )
        {
            connection.response.setStatusCode( '302', 'Found' );
            connection.response.setResponseHeader( 'Location', 'content/' );
            connection.response.close();
        }
    );
    
    /*
     *  fileInfo
     */
    function fileInfo( file, url )
    {
		var tmpFile = {};
		tmpFile.key            = (file.isDirectory?0:1)+ unescape( file.name.toLowerCase() );
		tmpFile.isDirectory    = file.isDirectory;
		tmpFile.type           = getFileType(file);
		tmpFile.action         = tmpFile.type == 'Music' ? _('Play') : tmpFile.type == 'Image' ? _('View') : tmpFile.type == 'Page' ? _('View') : tmpFile.isDirectory == true ? _('View') : ' ';
		tmpFile.fileLocation   = opera.io.webserver.currentServicePath.slice(0,-1)+(url||"/");
		tmpFile.fileName       = /*decodeURIComponent*/unescape( file.name );
		tmpFile.fileSize       = file.isDirectory?'':file.fileSize.formatFileSize();
		tmpFile.modifiedDate   = file.modified.toISOString();
		return tmpFile;      
    }
    
    /*
     *  register a requestHandle
     *  Yusef will do the ACL, call the requestHandle with the requestPath, visitorAccessType, pathAccessType arguments
     *  which must return an object with: content [, advancedSettings] [, ... ]
     */
    //Yusef.requestHandle = function( connection, data )
    Yusef.addSectionListener("content", function( connection )
    {
        var data = Yusef.getData( connection );
        var tmpl = new Markuper( 'templates/fileSharing.html', data );

        data.downloadUrlSuffix      = DOWNLOAD_URI_SUFFIX;
        data.noSharedMountpoint     = !Yusef.mountpoints.shared;
        //opera.postError( 'data.noSharedMountpoint = '+ data.noSharedMountpoint );
        if( data.noSharedMountpoint )
        {   //  no shared mountpoint
            // FIXME: Not to be translated because of US-1197
            data.title    = 'Not a shared folder';
        }
        else
        {
            var files           = Yusef.mountpoints.shared.resolve( ROOT_PATH + connection.request.path );
            
            if( !files.exists ) { return Yusef.emitErrorPage( connection ); }

//            opera.postError( 'up\t'+connection.request.path+'\nuup\t'+unescape(connection.request.path)+'\nfp\t'+files.path+'\nufp\t'+unescape(files.path)+'\n \nthe file does '+(files.exists?'':'NOT ')+' exist' )

            //  ? the file /shared/<requestPath> does not exists -> ?!?!
            if( files.exists )
            {
                //  ? the file /shared/<requestPath> is a file -> return it
                if( files.exists && !files.isDirectory )
                {
                    var fileName        = files.path.replace(/^mountpoint:\/\/shared\//, "");
                    var fullPath        = opera.io.webserver.currentServicePath+'content/' + fileName;
                    var fullPathAbsolute = 'http://'+connection.request.headers.Host[0] + fullPath;
                    
                    _activityStream.publish(_("File {fileName} was viewed", {"fileName": fileName}), ActivityVerbType.View,
                        new ActivityObjectModel(ActivityObjectType.File, fileName, fullPathAbsolute), null);
                    
                    if( connection.request.uri.slice( -DOWNLOAD_URI_SUFFIX.length )===DOWNLOAD_URI_SUFFIX )
                    {
                        showDownloadNotification(connection, files);
                        return Yusef.serveFile( connection, files, 'application/octet-stream' );
                    }
                    else
                    {
                        return Yusef.serveFile( connection, files );
                    }
                }


                //  ? the file /shared/<requestPath> is a folder -> crawl it
                files.refresh();
                var totalFileSize   = 0,
                    countFiles      = 0,
                    countFolders    = 0;


                var fileList = [];

                //  crawl the folder
                for( var i=0, file; file=files[i]; i++ )
                {
                    if( file.isHidden )
                    {
                        continue;
                    }
                    var path = file.path.slice( ROOT_PATH.length )+(file.isDirectory?'/':'');
                    var url = "/" + connection.request.section + path.replace( /\/\//g, '/' ); // US-260
                    var hasAccess = Yusef.plugins.acl.hasAccess( connection, connection.request.section, path );
                   
                    if( hasAccess )
                    {
                        if( file.isDirectory )
                        {
                            countFolders++;
                        }
                        else
                        {
                            countFiles++;
                        }
                        totalFileSize   += file.fileSize;

						try
						{
							var tmpFile = fileInfo( file, url );
							fileList.push( tmpFile );
						}
						catch( e )
						{
							opera.postError( _enumerateObject( tmpFile, 'tmpFile' ) +'\n'+ e );
						}
                    }
                }


                //  sort files
                fileList = fileList.sort( function( a,b ){ return a.key>b.key?1:-1; } );
                //if( data.requestPath=='/' )
                //{
                //    tmpl.select( '#parentResource' ).remove();
                //}

                if( files.parent.exists )
                {
                    var file    = files.parent;
                    var path    = file.path.slice( ROOT_PATH.length )+(file.isDirectory?'/':'');
                    var url     = "/" + connection.request.section + path.replace( /\/\//g, '/' ); // US-260
                    data.parentDirectory    = fileInfo( file, url );
                }


                //var accessInfo = Yusef.getResourceAccessInformation( data.session, (files.path.slice( ROOT_PATH.length )||'/')+(files.isDirectory?'/':'') );
                data.files =
                {
                    title           : escape( files.path.slice( ROOT_PATH.length ).split('/').pop()||'' ),
                    list            : fileList,
                    fileCount       : countFiles,
                    folderCount     : countFolders,
                    totalFileSize   : totalFileSize.formatFileSize()
                };

                //  breadcrumb
                data.breadcrumb = getResourcePathObject( files, connection.request.section);
				if ( files.path===Yusef.mountpoints.shared.path )
				{
					data.breadcrumb.HTMLName = opera.io.webserver.currentServiceName;
					data.breadcrumb.parentName = '';
				}
				else
				{
					data.breadcrumb.parentName = ( files.parent.path === Yusef.mountpoints.shared.path )?opera.io.webserver.currentServiceName:unescape( files.parent.name ).HTMLEntities();
				}
				
				
				data.isOwner = connection.isOwner;
            }
        }
        tmpl.parse( data );

        var tabs = [
            {"title": opera.io.webserver.currentServiceName, "section": "content", "url": opera.io.webserver.currentServicePath , "class": 'active'},
            {"title": _("Activity Feed"), "section": "activity"}
        ];
        
        if( data.isOwner )
        {
            tabs.push({"title": _("Help"), "section": "help"});
        }

        return {
            title   : connection.request.path,
            content : tmpl.select( '#filesharing' ),
            //styles  : [{href: 'styles/fileSharing.css'}],
            tabs    : Yusef.plugins.ui.generateTabs(tabs, connection),
            plugins :
            {
                sharedFolderUI  : true
            }
        };
    }, {ui:true}
    );
    
    function showDownloadNotification( connection, file )
    {
        if( connection.isOwner ) { return; }
        
        // 10MB
        var treeshold = 10*1024*1024;
        
        if( file.fileSize >= treeshold )
        {
            widget.showNotification(_("A large file is being downloaded: {filenamesize}", {filenamesize: file.fileSize.formatFileSize()}));
        }
    }
    
    function getFileType( file )
    {
        return file.isDirectory?'Folder':
               file.name.match(/\.mp3?$/i)?'Music':
               file.name.match(/\.(a?png|gif|jpe?g|bmp|ico)$/i)?'Image':
               file.name.match(/\.html?$/i)?'Page':
               'File';
    }

    init();
};

Date.prototype.toISOString = Date.prototype.toISOString || function()
{
    return this.getFullYear() + "-" + zeropad(this.getMonth() + 1) + "-" +
      zeropad(this.getDate()) + " " + zeropad(this.getHours()) + ":" +
      zeropad(this.getMinutes());
};

function zeropad(n)
{
    return ("0" + n).slice(-2);
}